// Simple class to disable interrupts in a C++ code block
// This does the right thing when nested calls are made.
// Simple include:
//
//  HoldInterrupts holdInt();
//
// At the top of any block of code where you want interrupts shut off.

#ifndef __HOLDINTERRUPTS__
#define __HOLDINTERRUPTS__

#ifndef MBED_H
#include "mbed.h"
#endif

class HoldInterrupts {
public:
    HoldInterrupts();
    ~HoldInterrupts();
};

#endif
